/* c_exceptions.cpp */
#include "c_exceptions.h"
#include <stdlib.h>

extern "C" {

	void CXCPT_throw(
		const char *message,
		CXCPT_ExceptionKind kind,
		void *data)
	{
		throw CXCPT_Exception(message, kind, data);
	}

	void CXCPT_try_catch(
		void (*action)(void *action_data),
		void *action_data,
		void (*handler)(void *handler_data, const char *message,
			CXCPT_ExceptionKind kind, void *exception_data),
		void *handler_data)
	{
		try {
			action(action_data);
		} catch(CXCPT_Exception &e) {
			handler(handler_data, e.message, e.kind, e.data);
		} catch(std::exception &e) {
			handler(handler_data, e.what(), NULL, NULL);
		} catch(...) {
			handler(handler_data, NULL, NULL, NULL);
		}
	}

	void CXCPT_rethrow() {
		throw;
	}

} // end extern "C"
